#include "troxmath.h"

inline double angle(const Vector &a, const Vector &b)
{
    return acos((a.x*b.x+a.y*b.y+a.z*b.z)/
		(sqrt((sqr(a.x)+sqr(a.y)+sqr(a.z))*(sqr(b.x)+sqr(b.y)+sqr(b.z)))));
}


Vector rotate(const Vector &k, const Tripel &d)
{
    Vector m,n,v;
    double sx,sy,sz, cx,cy,cz;
    sx=sin(d.wx); cx=cos(d.wx);
    sy=sin(d.wy); cy=cos(d.wy);
    sz=sin(d.wz); cz=cos(d.wz);
    m.x=cz*k.x+sz*k.y;
    m.y=cz*k.y-sz*k.x;
    v.x=cy*m.x+sy*k.z;
    n.z=cy*k.z-sy*m.x;
    v.y=cx*m.y+sx*n.z;
    v.z=cx*n.z-sx*m.y;
    return v;
}


Vector rerotate(const Vector &k, const Tripel &d)
{
    Vector m,n,v;
    double sx,sy,sz,cx,cy,cz;
    sx=sin(d.wx); cx=cos(d.wx);
    sy=sin(d.wy); cy=cos(d.wy);
    sz=sin(d.wz); cz=cos(d.wz);
    m.y=cx*k.y-sx*k.z;
    m.z=cx*k.z+sx*k.y;
    n.x=cy*k.x-sy*m.z;
    v.z=cy*m.z+sy*k.x;
    v.x=cz*n.x-sz*m.y;
    v.y=cz*m.y+sz*n.x;
    return v;
}


Tripel whereis(const World &w)
{
    // This is the rotine for inverse kinematics
    // Sorry that the comments are German, but _I_ have to understand them...
    Vector ny,nz;
    Tripel d;
    // Das sind y und die z-Achse, die wir mitdrehen werden.
    ny.x=0; ny.y=1.0; ny.z=0;
    nz.x=0; nz.y=0; nz.z=1.0;
    // 90-Winkel zwischen dem Vektor und der x-Achse
    d.wy = M_PI/2.0-angle(w.z,vect(1.0,0,0));
    // Winkel zwischen y/z-Komponente des Vektors und der z-Achse
    d.wx = angle(vect(0,w.z.y,w.z.z),vect(0,0,1.0));
    if (w.z.y<0) {d.wx=-d.wx;}
    // Jetzt kommt der Test, wie weit wir um die z-Achse htten drehen mssen,
    // um zu treffen:
    d.wz=0;
    ny=rotate(ny,d);
    nz=rotate(nz,d);
    d.wz=angle(ny,w.y);
    ny.x=0; ny.y=1.0; ny.z=0;
    // Haben wir auch um z-Achse korrekt gedreht?
    ny=rotate(ny,d);
    if (fabs(angle(ny,w.y))>0.0001) {d.wz=-d.wz;}
    return d;
}
